From e84a441c9d7c9c1657f008ab03f76b23733ea08f Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Javier=20Jard=C3=B3n?= <jjardon@gnome.org>
Date: Sat, 26 Aug 2023 11:02:44 +0100
Subject: [PATCH] Add option to disable creation of libdrm library

---
 amdgpu/meson.build    |  6 +++---
 etnaviv/meson.build   |  6 +++---
 exynos/meson.build    |  6 +++---
 freedreno/meson.build |  6 +++---
 intel/meson.build     |  9 +++++----
 meson.build           | 13 +++++++++++++
 meson_options.txt     |  8 ++++++++
 nouveau/meson.build   |  6 +++---
 omap/meson.build      |  6 +++---
 radeon/meson.build    |  6 +++---
 tegra/meson.build     |  6 +++---
 11 files changed, 50 insertions(+), 28 deletions(-)

diff --git a/amdgpu/meson.build b/amdgpu/meson.build
index 20bf6244..260522e0 100644
--- a/amdgpu/meson.build
+++ b/amdgpu/meson.build
@@ -35,8 +35,7 @@ libdrm_amdgpu = library(
     '-DAMDGPU_ASIC_ID_TABLE="@0@"'.format(join_paths(datadir_amdgpu, 'amdgpu.ids')),
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops, dep_rt],
+  dependencies : [dep_threads, dep_atomic_ops, dep_rt, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -51,7 +50,8 @@ pkg.generate(
 )
 
 ext_libdrm_amdgpu = declare_dependency(
-  link_with : [libdrm, libdrm_amdgpu],
+  link_with : [libdrm_amdgpu],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/etnaviv/meson.build b/etnaviv/meson.build
index 9ccf8696..395697bb 100644
--- a/etnaviv/meson.build
+++ b/etnaviv/meson.build
@@ -29,10 +29,9 @@ libdrm_etnaviv = library(
     config_file
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
-  dependencies : [dep_threads, dep_rt, dep_atomic_ops],
+  dependencies : [dep_threads, dep_rt, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -47,7 +46,8 @@ pkg.generate(
 )
 
 ext_libdrm_etnaviv = declare_dependency(
-  link_with : [libdrm, libdrm_etnaviv],
+  link_with : [libdrm_etnaviv],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/exynos/meson.build b/exynos/meson.build
index 6b4fe1e9..4895bb46 100644
--- a/exynos/meson.build
+++ b/exynos/meson.build
@@ -24,8 +24,7 @@ libdrm_exynos = library(
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads],
+  dependencies : [dep_threads, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
@@ -34,7 +33,8 @@ install_headers('exynos_drmif.h', subdir : 'libdrm')
 install_headers('exynos_drm.h', 'exynos_fimg2d.h', subdir : 'exynos')
 
 ext_libdrm_exynos = declare_dependency(
-  link_with : [libdrm, libdrm_exynos],
+  link_with : [libdrm_exynos],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/freedreno/meson.build b/freedreno/meson.build
index 5ba1a3f1..f2549416 100644
--- a/freedreno/meson.build
+++ b/freedreno/meson.build
@@ -44,14 +44,14 @@ libdrm_freedreno = library(
   [files_freedreno, config_file],
   c_args : libdrm_c_args,
   include_directories : [inc_root, inc_drm],
-  dependencies : [dep_valgrind, dep_threads, dep_rt, dep_atomic_ops],
-  link_with : libdrm,
+  dependencies : [dep_valgrind, dep_threads, dep_rt, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
 
 ext_libdrm_freedreno = declare_dependency(
-  link_with : [libdrm, libdrm_freedreno],
+  link_with : [libdrm_freedreno],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/intel/meson.build b/intel/meson.build
index 4af2a357..ad853bb5 100644
--- a/intel/meson.build
+++ b/intel/meson.build
@@ -28,8 +28,7 @@ libdrm_intel = library(
     config_file,
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_pciaccess, dep_threads, dep_rt, dep_valgrind, dep_atomic_ops],
+  dependencies : [dep_pciaccess, dep_threads, dep_rt, dep_valgrind, dep_atomic_ops, ext_libdrm],
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
   version : '1.0.0',
@@ -37,7 +36,8 @@ libdrm_intel = library(
 )
 
 ext_libdrm_intel = declare_dependency(
-  link_with : [libdrm, libdrm_intel],
+  link_with : [libdrm_intel],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
@@ -62,7 +62,8 @@ test_decode = executable(
   'test_decode',
   files('test_decode.c'),
   include_directories : [inc_root, inc_drm],
-  link_with : [libdrm, libdrm_intel],
+  link_with : [libdrm_intel],
+  dependencies : [ext_libdrm],
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
 )
diff --git a/meson.build b/meson.build
index 05f05fd9..07bf71f5 100644
--- a/meson.build
+++ b/meson.build
@@ -189,6 +189,12 @@ if not _vc4.disabled()
 endif
 summary('VC4', with_vc4)
 
+with_libdrm = true
+_libdrm = get_option('libdrm')
+if _libdrm == 'false'
+  with_libdrm = false
+endif
+
 # Among others FreeBSD does not have a separate dl library.
 if not cc.has_function('dlsym')
   dep_dl = cc.find_library('dl', required : with_nouveau)
@@ -297,6 +303,7 @@ else
   libdrm_kw = {'version' : '2.4.0'}
 endif
 
+if with_libdrm
 libdrm = library(
   'drm',
   libdrm_files,
@@ -327,6 +334,10 @@ if meson.version().version_compare('>= 0.54.0')
   meson.override_dependency('libdrm', ext_libdrm)
 endif
 
+else
+ext_libdrm = dependency('libdrm')
+endif
+
 install_headers('libsync.h', 'xf86drm.h', 'xf86drmMode.h')
 install_headers(
   'include/drm/drm.h', 'include/drm/drm_fourcc.h', 'include/drm/drm_mode.h',
@@ -344,12 +355,14 @@ if with_vmwgfx
   install_headers('include/drm/vmwgfx_drm.h', subdir : 'libdrm')
 endif
 
+if get_option('libdrm') != 'false'
 pkg.generate(
   libdrm,
   name : 'libdrm',
   subdirs : ['.', 'libdrm'],
   description : 'Userspace interface to kernel DRM services',
 )
+endif
 
 if with_intel
   subdir('intel')
diff --git a/meson_options.txt b/meson_options.txt
index e80d79e2..b6a85c04 100644
--- a/meson_options.txt
+++ b/meson_options.txt
@@ -18,6 +18,14 @@
 # OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 # SOFTWARE.
 
+option(
+  'libdrm',
+  type : 'combo',
+  value : 'true',
+  choices : ['true', 'false'],
+  description : 'Build libdrm library.',
+)
+
 option(
   'intel',
   type : 'feature',
diff --git a/nouveau/meson.build b/nouveau/meson.build
index 350f34c4..5d72941a 100644
--- a/nouveau/meson.build
+++ b/nouveau/meson.build
@@ -25,14 +25,14 @@ libdrm_nouveau = library(
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops],
+  dependencies : [dep_threads, dep_atomic_ops, ext_libdrm],
   version : '2.0.0',
   install : true,
 )
 
 ext_libdrm_nouveau = declare_dependency(
-  link_with : [libdrm, libdrm_nouveau],
+  link_with : [libdrm_nouveau],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/omap/meson.build b/omap/meson.build
index eebd1420..d647dcf3 100644
--- a/omap/meson.build
+++ b/omap/meson.build
@@ -24,14 +24,14 @@ libdrm_omap = library(
   include_directories : [inc_root, inc_drm],
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops],
+  dependencies : [dep_threads, dep_atomic_ops, ext_libdrm],
   version : '1.0.0',
   install : true,
 )
 
 ext_libdrm_omap = declare_dependency(
-  link_with : [libdrm, libdrm_omap],
+  link_with : [libdrm_omap],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/radeon/meson.build b/radeon/meson.build
index dda3877a..7687430f 100644
--- a/radeon/meson.build
+++ b/radeon/meson.build
@@ -31,14 +31,14 @@ libdrm_radeon = library(
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops],
+  dependencies : [dep_threads, dep_atomic_ops, ext_libdrm],
   version : '1.0.1',
   install : true,
 )
 
 ext_libdrm_radeon = declare_dependency(
-  link_with : [libdrm, libdrm_radeon],
+  link_with : [libdrm_radeon],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
diff --git a/tegra/meson.build b/tegra/meson.build
index 5325ed74..1b4ee3a0 100644
--- a/tegra/meson.build
+++ b/tegra/meson.build
@@ -27,8 +27,7 @@ libdrm_tegra = library(
     config_file
   ],
   include_directories : [inc_root, inc_drm],
-  link_with : libdrm,
-  dependencies : [dep_threads, dep_atomic_ops],
+  dependencies : [dep_threads, dep_atomic_ops, ext_libdrm],
   c_args : libdrm_c_args,
   gnu_symbol_visibility : 'hidden',
   version : '0.0.0',
@@ -36,7 +35,8 @@ libdrm_tegra = library(
 )
 
 ext_libdrm_tegra = declare_dependency(
-  link_with : [libdrm, libdrm_tegra],
+  link_with : [libdrm_tegra],
+  dependencies : [ext_libdrm],
   include_directories : [inc_drm, include_directories('.')],
 )
 
-- 
2.41.0

